#ifdef STATISTICS
/*
 * $Id: RegisterFile_Multi_Banked_statistics_declaration.cpp 137 2010-02-16 12:35:48Z rosiere $
 *
 * [Description ]
 * 
 */

#include "Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/include/RegisterFile_Multi_Banked.h"

namespace morpheo {
namespace behavioural {
namespace generic {
namespace registerfile {
namespace registerfile_multi_banked {

#undef  FUNCTION
#define FUNCTION "RegisterFile_Multi_Banked::statistics_declaration"
  void RegisterFile_Multi_Banked::statistics_declaration (morpheo::behavioural::Parameters_Statistics * param_statistics)
  {
    log_printf(FUNC,RegisterFile_Multi_Banked,FUNCTION,"Begin");

    _stat = new Stat (static_cast<std::string>(_name),
		      "RegisterFile_Multi_Banked",
		      param_statistics);

//     _stat_nb_read              = _stat->create_variable("nb_read" );
//     _stat_nb_write             = _stat->create_variable("nb_write");
//     _stat_nb_conflict_on_read  = _stat->create_variable("nb_conflict_on_read" );
//     _stat_nb_conflict_on_write = _stat->create_variable("nb_conflict_on_write");

    _stat_nb_read              = _stat->create_counter("nb_read"             ,"","");
    _stat_nb_write             = _stat->create_counter("nb_write"            ,"","");
    _stat_nb_conflict_on_read  = _stat->create_counter("nb_conflict_on_read" ,"","");
    _stat_nb_conflict_on_write = _stat->create_counter("nb_conflict_on_write","","");

    _stat->create_expr_average_by_cycle("average_read" , "nb_read" , "", _("Average read by cycle" ));
    _stat->create_expr_average_by_cycle("average_write", "nb_write", "", _("Average write by cycle"));

    _stat->create_expr_percent         ("percent_conflict_on_read" , "nb_conflict_on_read" , "+ nb_read  nb_conflict_on_read" , _("Percent conflit on read port" ));
    _stat->create_expr_percent         ("percent_conflict_on_write", "nb_conflict_on_write", "+ nb_write nb_conflict_on_write", _("Percent conflit on write port"));
    
    log_printf(FUNC,RegisterFile_Multi_Banked,FUNCTION,"End");
  };

}; // end namespace registerfile_multi_banked
}; // end namespace registerfile
}; // end namespace generic

}; // end namespace behavioural
}; // end namespace morpheo              
#endif
